<!-- https://eugenkiss.github.io/7guis/tasks#crud -->
<script lang="ts">
  import type { ProductOptionModel } from "src/models/product.type";

  export let disable = false;
  export let productOptionList: ProductOptionModel[] = [];
  export let customCss: string = "";

  let productName = "";
  let instock: number = 0;
  let i = 0;

  $: filteredPeople = productOptionList;

  $: selected = filteredPeople[i];

  $: reset_inputs(selected);

  function create() {
    productOptionList = productOptionList.concat({ productName, instock });
    i = productOptionList.length - 1;
    productName = "";
    instock = 0;
  }

  function update() {
    selected.productName = productName;
    selected.instock = instock;
    productOptionList = productOptionList;
  }

  function remove() {
    // Remove selected person from the source array (productOptionList), not the filtered array
    const index = productOptionList.indexOf(selected);
    productOptionList = [
      ...productOptionList.slice(0, index),
      ...productOptionList.slice(index + 1),
    ];

    productName = "";
    instock = 0;
    i = Math.min(i, filteredPeople.length - 2);
  }

  function reset_inputs(person: any) {
    productName = person ? person.productName : "";
    instock = person ? person.instock : "";
  }
</script>

<div class="flex flex-col p-3 bg-gray-200 rounded {customCss}">
  <select class="rounded" bind:value={i} size={5}>
    {#each filteredPeople as person, i}
      <option value={i}
        >{i + 1}. {person.productName}, จำนวน {person.instock} หน่วย
      </option>
    {/each}
  </select>

  {#if !disable}
    <p>ชื่อตัวเลือกสินค้า</p>
    <input
      type="text"
      class="p-2 my-1 rounded"
      bind:value={productName}
      placeholder="ชื่อตัวเลือกสินค้า"
    />

    <p>จำนวนในคลัง</p>
    <input
      type="number"
      class="p-2 my-1 rounded"
      bind:value={instock}
      placeholder="จำนวนในคลัง"
    />

    <div class="w-full sm:flex md:flex lg:flex">
      <button
        class="bg-green-500 hover:bg-green-600 text-white p-2 cursor-pointer w-full"
        on:click={create}
        disabled={!productName || !instock}>create</button
      >
      <button
        class="bg-yellow-500 hover:bg-yellow-600 text-white p-2 cursor-pointer w-full"
        on:click={update}
        disabled={!productName || !instock || !selected}>update</button
      >
      <button
        class="bg-red-500 hover:bg-red-600 text-white p-2 cursor-pointer w-full"
        on:click={remove}
        disabled={!selected}>delete</button
      >
    </div>
  {/if}
</div>
